### What is otclient?

Otclient is an alternative Tibia client for usage with otserv. It aims to be complete and flexible,
for that it uses LUA scripting for all game interface functionality and configurations files with a syntax
similar to CSS for the client interface design. Otclient works with a modular system, this means
that each functionality is a separated module, giving the possibility to users modify and customize
anything easily. Users can also create new mods and extend game interface for their own purposes.
Otclient is written in C++2011, the upcoming C++ standard and heavily scripted in lua.

### Features

Beyond of it's flexibility with scripts, otclient comes with tons of other features that make possible
the creation of new client side stuff in otserv that was not possible before. These include,
sound system, graphics effects with shaders, particle engines, modules/addons system, animated textures,
styleable user interface, transparency, multi language, in game lua terminal, an OpenGL 1.1/2.0 ES engine that make possible to
run on mobile platforms like Android/iPhone/iPad and much more. Otclient is also flexible enough to
create tibia tools like map editors just using scripts, because it wasn't designed to be just a
client, instead otclient was designed to be a combination of a framework and tibia APIs.

### Download

Daily snapshots of otclient master branch compiled for Windows and protocol 860 is available
in the [downloads section](https://github.com/edubart/otclient/downloads) of the project's github page.
For any other platform or protocol you will need to compile the source code. Currently Linux/Windows
platforms and protocols 8.6x are supported.

### Compiling

In short, if you need to compile OTClient, follow these tutorials:
* [Compiling on Windows](http://otclient.info/tutorials/compiling_on_windows.html)
* [Compiling on Linux](http://otclient.info/tutorials/compiling_on_linux.html)

### Need help?

Checkout our website at <http://otclient.info> for tutorials and more information.
If you have any questions or are looking for more information, please feel free to ask on our official
forum at <http://forum.otclient.info> or talk with us at #otclient irc.freenode.net

### Bugs

Have found a bug? Please create an issue in our [bug tracker](https://github.com/edubart/otclient/issues)

### Contributing

We encourage you to contribute to otclient! Please check out
[our website](http://otclient.info/) for guidelines about how to proceed. Join us!

We are currently needing help in the following areas:
* Designing new UI themes or improving the current one
* Translating the client to other languages
* Documenting and creating tutorials
* Scripting new modules or improving the current ones
* Porting otclient to other otserv protocols (8.54, 8.7, 9.x, etc)
* Spreading otclient project over the web and bring it to new possible contributors
* Testing the client itself to report bugs and missing features in our bug tracker

### Contact

You have 3 options, use the [forum](http://forum.otclient.info/), talk directly with us at #otclient irc.freenode.net
or send an email directly to the project leader edub4rt@gmail.com

### License

Otclient is made available under the MIT License, thus this means that you are free
to do whatever you want, commercial, non-commercial, closed or open.


### Donate

Otclient needs your support, if you really like and use it, please donate. Anyone can donate
by clicking the Donate button in otclient website. We might prioritize features
requests from who donate, in this case you can send an email to the project leader.
